@echo off

:/*==============================================================*\
: |                                                              |
: | Hello! This is the tutorial batch file of PowerBatch! Look   |
: | through it and don't be annoyed by the large number of pa-   |
: | rameters used in my calls of the pb (= PowerBatch) execu-    |
: | table! What I do here is to make _HEAVY_ use of PowerBatch's |
: | capabilities. This could be YOUR batch file already! Think   |
: | of using nice menus, mouse control and hotkeys instead of    |
: | choice and echo orgys! And all this is for free! If you      |
: | really want to use it regularly, let me have $ 20,-- or      |
: | at least send me a nice nice nice post card of where you     |
: | live! My son would be so glad receiving post cards from all  |
: | over the world, so just go for it and let me have one. If    |
: | you want to, I can send you one of where I live, as well.    |
: |                                                              |
: | Hallo! Dies ist das Hilfeprogramm von PowerBatch! Sehen Sie  |
: | sich ruhig alles an und lassen Sie sich nicht von den vie-   |
: | len Parametern schocken, die ich in den Aufrufen von pb      |
: | (= PowerBatch) verwende! Ich verwende hier _EXTENSIV_ die    |
: | Mglichkeiten von PowerBatch. Dies knnte bereits IHR Batch  |
: | File sein! Denken Sie einmal an die schnen Mens mit Maus-  |
: | steuerung, Tastenkrzeln u.a., die Sie jetzt ganz einfach    |
: | realisieren knnen! Ohne Choice- und Echo-Orgien! Und all    |
: | das "fr lau"! Wenn Sie das Programm wirklich regelmig     |
: | verwenden wollen, senden Sie mir einfach DM 30,-- oder       |
: | schicken Sie mir eine hbsche Postkarte von Ihrem Wohnort    |
: | oder aus dem Urlaub! Mein Sohn ist ganz wild darauf, Post-   |
: | karten aus der ganzen Welt zu bekommen, also auf auf,        |
: | schicken Sie mir einfach eine, und wenn Sie mchten, schreibe|
: | ich auch zurck. Vielen Dank im voraus.                      |
: |                                                              |
: | Matthias Nott -- Alte Uslarer Strae 9b -- D-37181 Hardegsen |
: |        Tel. (++49) 5505 1542 -- Fax (++49) 5505 2807         |
: |                     EMAIL: MNOTT@GWDG.DE                     |
: |                                                              |
: |                                                              |
: |                                                              |
: | TO DO:   * Text input / output to an environment variable.   |
: |            This one will be quite difficult. The input       |
: |            functionality is allready built in, but not       |
: |            yet activated, since there is no output so far    |
: |            (it's difficult and insecure to modify master     |
: |            environemnt).                                     |
: |          * Allow scrollbars -> get a full featured text      |
: |            previewer. That shouldn't be too difficult.       |
: |          * Support screen modes other than 80*25 (the pro-   |
: |            gram doesn't care about them, but lets you use    |
: |            80*25 only. This should be quite easy anyway.     |
: |          * Allow the menu bar remaining in the same line     |
: |            as it was when you made a selection (it will      |
: |            go back to the first line since the menu is       |
: |            redrawn completely). This _is_ possible with      |
: |            the option "choose automatically" together with   |
: |            "after 0 seconds" (that is go to a defined menu   |
: |            item and do nothing else). But you would have to  |
: |            hack around with your batch file. Any ideas any-  |
: |            one?                                              |
: |          * Convince people of paying or at least of sending  |
: |            post cards for my son. :) As a child you would    |
: |            have been excited as well about post cards from   |
: |            all over the world, wouldn't you???               |
: |                                                              |
:\*==============================================================*/



:/*--------------------------------------------------------------*\
: |  Zuerst die Auswahl der richtigen Sprache (deutsch/englisch) |
: |  First choose the right language (german/english)            |
: |  Deutsche Dateien = *.ger, englische Dateien = *.eng         |
: |  German files     = *.ger, english files     = *.eng         |
: |                                                              |
: |  Zugleich ist dies hier die einfachste Form eines Mens:     |
: |  Der Benutzer kann zwischen zwei Optionen whlen. Das Men   |
: |  wird zustzlich auf einem grauen Fensterhintergrund (back-  |
: |  groun.men) mit Titelzeile (title.men) und Statuszeile       |
: |  (status0.men) dargestellt. Der Mentext selbst steht in     |
: |  der Datei lang.men.                                         |
: |                                                              |
: |  Meanwhile, this is an example for a simple menu: The user   |
: |  can choose from two options. Additionally, the menu is dis- |
: |  played on a nice grey background (backgrou.men), with title-|
: |  bar (title.men) and status line (status0.men). The menu     |
: |  entries themselves reside in lang.men.                      |
:\*--------------------------------------------------------------*/

pb backgrou.men  -fh0 -ft7  -x1  -y1 -r0  -s0
pb titel.men     -fh1 -ft15 -x2  -y2
pb status0.men   -fh7 -ft0  -x1 -y25 -r0  -s0
pb lang.men      -fh1 -ft15 -fn0 -m1 -mm1 -mx4 -my3
if errorlevel 254 goto END
if errorlevel 2   goto ENGHALLO
if errorlevel 1   goto GERHALLO



:/*==============================================================*\
: |                                                              |
: | Dies ist das deutsche Hilfesystem. Die englische Fassung ist |
: | weiter unten! This is the German tutorial. See below for the |
: | english version!                                             |
: |                                                              |
:\*==============================================================*/


:/*--------------------------------------------------------------*\
: |                    Anzeigen des Hauptmens:                  |
:\*--------------------------------------------------------------*/
:GERHALLO

pb backgrou.men  -fh0 -ft7  -x1  -y1 -r0  -s0
pb titel.ger     -fh1 -ft15 -x2  -y2


:/*--------------------------------------------------------------*\
: |                   Auswerten des Hauptmens:                  |
:\*--------------------------------------------------------------*/
:GERMENU

pb status.ger    -fh7 -ft0  -x1 -y25 -r0  -s0
pb menu.ger      -fh1 -ft15 -fn0 -m1 -mm1 -mx4 -my3 -o1
if errorlevel 254 goto END
if errorlevel 6   goto GERINFO
if errorlevel 5   goto GERMENU
if errorlevel 4   goto GERPARAM
if errorlevel 3   goto GERLOOK
if errorlevel 2   goto GERLEARN
if errorlevel 1   goto GERINTRO



:/*--------------------------------------------------------------*\
: |                    Einfhrungsbildschirm:                    |
:\*--------------------------------------------------------------*/
:GERINTRO

pb backgrou.men  -fh0 -ft7   -x1 -y1    -r0 -s0
pb status8.ger   -fh7  -ft0  -x1 -y25   -r0 -s0
pb intro1.ger    -ft15 -u3   -y1 -fu142
pb intro1b.ger   -o1   -y2   -x7 -r0    -s0 -ft14 -mm1
rem Ja, ja... Unterschiedliche Textfarbein in einem Textfenster
rem sind nur ein Tuschungsmanver :) In Wirklichkeit wird ein
rem Teil des Textfensters (intro1.ger) in einer anderen Farbe
rem (intro1b.ger) noch einmal darbergelegt.
pb backgrou.men  -fh0 -ft7   -x1 -y1    -r0 -s0
pb status8.ger   -fh7  -ft0  -x1 -y25   -r0 -s0
pb intro2.ger    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro3.ger    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro4.ger    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro5.ger    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro6.ger    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro7.ger    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro8.ger    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro9.ger    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro10.ger   -ft15 -u3   -y1 -fu142 -o1 -mm1
pb titel.ger     -fh1 -ft15  -x2 -y2
pb intro11.ger   -ft15 -u3   -y6 -fu142 -o1 -mm1
goto GERHALLO



:/*--------------------------------------------------------------*\
: |                     Lernen und Verstehen:                    |
:\*--------------------------------------------------------------*/
:GERLEARN

pb status1b.ger    -fh7 -ft0  -x1 -y25 -r0  -s0
pb learn.ger      -fh1 -ft15 -m1 -mm1 -x2 -y6
if errorlevel 254 goto GERMENU
if errorlevel 3   goto GERFARBELEARN
if errorlevel 2   goto GERTEXTLEARN
if errorlevel 1   goto GERMENULEARN

:GERMENULEARN
pb status8.ger    -fh7 -ft0  -x1  -y25   -r0 -s0
pb batch1.ger     -fh1 -ft15 -y1
pb batch1b.ger    -fh1 -ft15 -y12
pb status9.ger    -fh7 -ft0  -x1  -y25 -r0   -s0  -o1 -mm1 -mx40 -my12
pb status9.ger    -fh7 -ft0  -x1  -y25 -r0   -s0      -mm1 -mx40 -my12
pb batch11.ger    -fh1 -ft15 -y3  -mm1 -o1
pb batch12.ger    -fh1 -ft15 -y4  -mm1 -o1
pb batch13.ger    -fh1 -ft15 -y5  -mm1 -o1
pb batch14.ger    -fh1 -ft15 -y6  -mm1 -o1
pb batch15.ger    -fh1 -ft15 -y7  -mm1 -o1
pb batch16.ger    -fh1 -ft15 -y7  -mm1 -o1
pb batch17.ger    -fh4 -ft14 -y7  -mm1 -o1   -fr142
pb status10.ger   -fh4 -ft14 -x1  -y25 -r0   -s0  -o1 -mm1 -mx40 -my12
rem Oben wurde brigens hufig nur die vertikale Lage der Fenster
rem definiert, dann wird das Fenster horizontal automatisch zentriert.
goto GERHALLO

:GERTEXTLEARN
rem Dies ist ein typisches Beispiel fr die Darstellung einer einfachen
rem Textbox, hier noch zusammen mit einer Statuszeile.
pb status1c.ger   -fh7 -ft0  -x1  -y25 -r0   -s0
pb batch21.ger    -fh1 -ft15 -mm1 -o1
goto GERLEARN

:GERFARBELEARN
rem Dies ist ein typisches Beispiel fr die Darstellung einer einfachen
rem Textbox, hier noch zusammen mit einer Statuszeile.
pb status1c.ger   -fh7 -ft0  -x1  -y25 -r0   -s0
pb batch31.ger    -fh1 -ft15 -mm1 -o1
goto GERLEARN



:/*--------------------------------------------------------------*\
: |               Anzeigen der Farbtabelle/Beispiele:            |
:\*--------------------------------------------------------------*/
:GERLOOK

pb status2.ger -fh7  -ft0   -x1  -y25 -r0 -s0
pb farben.ger  -ft15 -u3    -y1  -x2
pb farben2.ger -fh0  -x66   -y5  -r0  -s0 
pb farben2.ger -fh1  -x66   -y6  -r0  -s0
pb farben2.ger -fh2  -x66   -y7  -r0  -s0
pb farben2.ger -fh3  -x66   -y8  -r0  -s0
pb farben2.ger -fh4  -x66   -y9  -r0  -s0
pb farben2.ger -fh5  -x66   -y10 -r0  -s0
pb farben2.ger -fh6  -x66   -y11 -r0  -s0
pb farben2.ger -fh7  -x66   -y12 -r0  -s0
pb farben3.ger -fh0  -ft8   -x66 -y13 -r0 -s0
pb farben3.ger -fh0  -ft9   -x66 -y14 -r0 -s0
pb farben3.ger -fh0  -ft10  -x66 -y15 -r0 -s0
pb farben3.ger -fh0  -ft11  -x66 -y16 -r0 -s0
pb farben3.ger -fh0  -ft12  -x66 -y17 -r0 -s0
pb farben3.ger -fh0  -ft13  -x66 -y18 -r0 -s0
pb farben3.ger -fh0  -ft14  -x66 -y19 -r0 -s0
pb farben3.ger -fh0  -ft15  -x66 -y20 -r0 -s0
pb farben3.ger -fh0  -ft143 -x66 -y21 -r0 -s0 -o1 -mm1 -my12 -mx40
rem Die letzte Zeile wartet auf den Tastendruck: Es ist einfach
rem das letzte Farbbeispiel, dem wir mitteilen "warte auf Tasten-
rem druck!". Natrlich knnte man anstelle dessen auch die Status-
rem zeile dazu bringen, auf den Tastendruck zu warten; ich wollte
rem an dieser Stelle die Statuszeile aber zuerst auf dem Bildschirm
rem haben, vor den Farbbeispielen.
goto GERHALLO



:/*--------------------------------------------------------------*\
: |                 Anzeigen der Programmparameter:              |
:\*--------------------------------------------------------------*/
:GERPARAM

pb param.ger      -fh1 -ft15 -m1 -mm1 -x35 -y6
if errorlevel 254 goto GERMENU
if errorlevel 7   goto GERPA7
if errorlevel 6   goto GERPA6
if errorlevel 5   goto GERPA5
if errorlevel 4   goto GERPA4
if errorlevel 3   goto GERPA3
if errorlevel 2   goto GERPA2
if errorlevel 1   goto GERPA1

:GERPA1
pb status2.ger -fh7 -ft0 -x1 -y25 -r0 -s0
pb param1.ger  -ft15 -o1 -mm1 -u3 -y2 -x2
goto GERPARAM

:GERPA2
pb status2.ger -fh7 -ft0 -x1 -y25 -r0 -s0
pb param2.ger  -ft15 -o1 -mm1 -u3 -y2 -x2
goto GERPARAM

:GERPA3
pb status2.ger -fh7 -ft0 -x1 -y25 -r0 -s0
pb param3.ger  -ft15 -o1 -mm1 -u3 -y1 -x2
goto GERPARAM

:GERPA4
pb status2.ger -fh7 -ft0 -x1 -y25 -r0 -s0
pb param4.ger  -ft15 -o1 -mm1 -u3 -y2 -x2
goto GERPARAM

:GERPA5
pb status2.ger -fh7 -ft0 -x1 -y25 -r0 -s0
pb param5.ger  -ft15 -o1 -mm1 -u3 -y1 -x2
goto GERPARAM

:GERPA6
pb status2.ger -fh7 -ft0 -x1 -y25 -r0 -s0
pb param6.ger  -ft15 -o1 -mm1 -u3 -y2 -x2
goto GERPARAM

:GERPA7
pb status2.ger -fh7 -ft0 -x1 -y25 -r0 -s0
pb param7.ger  -ft15 -o1 -mm1 -u3 -y1 -x2
goto GERPARAM



:/*--------------------------------------------------------------*\
: |               Anzeigen der Info - Demonstration:             |
:\*--------------------------------------------------------------*/
:GERINFO

pb backgrou.men  -fh0 -ft7  -x1  -y1 -r0 -s0
pb titel.ger     -fh1 -ft15 -x2  -y2
pb status3.ger -fh7  -ft0 -x1   -y25  -r0  -s0
pb info1.ger   -ft15 -o1  -mm1   -u3  -r5
pb info2.ger   -ft15 -o1  -mm1   -u3  -r5
pb info3.ger   -ft15 -o1  -mm1   -u3  -r5
pb info4.ger   -ft15 -o1  -mm1   -u3  -r5
pb info5.ger   -ft15 -o1  -mm1   -u3  -r5
pb info6.ger   -ft15 -o1  -mm1   -u3  -r5
pb info7.ger   -ft15 -o1  -mm1   -u3  -r5  -y6  -x4
pb naomi1.ger  -ft14 -fh4 -fr142 -o1  -mm1 -mx4 -my3
pb naomi2.ger  -ft14 -fh4 -fr142 -o1  -mm1 -mx4 -my3
pb status4.ger -fh2  -ft142 -x1  -y25 -r0  -s0
pb naomi3.ger  -ft14 -fh4 -fr14  -o1  -mm1 -mx4 -my3
pb status5.ger -fh7  -ft0  -x1   -y25 -r0  -s0
pb flagge1.ger -ft14 -fh0  -x2   -y7  -r3
pb status5.ger -fh7  -ft0  -x1   -y25 -r0  -s0  -o1  -mm1 -mx4 -my3
pb flagge2.ger -ft15 -fh4  -x2   -y12 -r3
pb status5.ger -fh7  -ft0  -x1   -y25 -r0  -s0  -o1  -mm1 -mx4 -my3
pb flagge3.ger -ft0  -fh14 -r3   -y17 -x2
pb status5.ger -fh7  -ft0  -x1   -y25 -r0  -s0  -o1  -mm1 -mx4 -my3
pb flagge4.ger -ft14 -fr14 -x56  -y7  -r5
pb status5.ger -fh7  -ft0  -x1   -y25 -r0  -s0  -o1  -mm1 -mx4 -my3
pb status6.ger -fh7  -ft0  -x1   -y25 -r0  -s0
pb kasten1.ger -ft14 -fh0  -r3   -mm1 -mx4 -my3 -y7  -x2  -aw1 -p10
pb kasten2.ger -ft14 -fh4  -r3   -mm1 -mx4 -my3 -y8  -x3  -aw1 -p20
pb kasten3.ger -ft14 -fh14 -r3   -mm1 -mx4 -my3 -y9  -x4  -aw1 -p30
pb kasten4.ger -ft14 -fh0  -r3   -mm1 -mx4 -my3 -y10 -x5  -aw1 -p40
pb kasten5.ger -ft14 -fh4  -r3   -mm1 -mx4 -my3 -y11 -x6  -aw1 -p50
pb kasten6.ger -ft14 -fh14 -r3   -mm1 -mx4 -my3 -y12 -x7  -aw1 -p60
pb status7.ger -fh7  -ft0  -x1   -y25 -r0  -s0
pb kasten7.ger -ft14 -fh3 -fr11  -r3  -mm1 -mx4 -my3 -y11 -o1 -p100
goto GERHALLO




 
:/*==============================================================*\
: |                                                              |
: | This is the english tutorial. See above for the german ver-  |
: | sion! All labels start with a 'ENG' instead of the 'GER' as  |
: | used above. All source files have '.eng' instead of '.ger'   |
: | as extension.                                                |
: |                                                              |
:\*==============================================================*/


:/*--------------------------------------------------------------*\
: |                   Let's show the main menu:                  |
:\*--------------------------------------------------------------*/
:ENGHALLO

pb backgrou.men  -fh0 -ft7  -x1  -y1 -r0  -s0
pb titel.eng     -fh1 -ft15 -x2  -y2


:/*--------------------------------------------------------------*\
: |                     Treat user's choice:                     |
:\*--------------------------------------------------------------*/
:ENGMENU

pb status.eng    -fh7 -ft0  -x1 -y25 -r0  -s0
pb menu.eng      -fh1 -ft15 -fn0 -m1 -mm1 -mx4 -my3 -o1
if errorlevel 254 goto END
if errorlevel 6   goto ENGINFO
if errorlevel 5   goto ENGMENU
if errorlevel 4   goto ENGPARAM
if errorlevel 3   goto ENGLOOK
if errorlevel 2   goto ENGLEARN
if errorlevel 1   goto ENGINTRO


:/*--------------------------------------------------------------*\
: |                   This is the introduction!                  |
:\*--------------------------------------------------------------*/
:ENGINTRO

pb backgrou.men  -fh0 -ft7   -x1 -y1    -r0 -s0
pb status8.eng   -fh7  -ft0  -x1 -y25   -r0 -s0
pb intro1.eng    -ft15 -u3   -y1 -fu142
pb intro1b.eng   -o1   -y2   -x7 -r0    -s0 -ft14 -mm1
rem Ok, ok... Different text colors in a single text box are
rem just for your confusion :) What I really do here is to
rem put the text box (intro1.eng) on the screen and to drop
rem another text box (intro1b.eng), with different colors, on
rem top of it.
pb backgrou.men  -fh0 -ft7   -x1 -y1    -r0 -s0
pb status8.eng   -fh7  -ft0  -x1 -y25   -r0 -s0
pb intro2.eng    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro3.eng    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro4.eng    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro5.eng    -ft15 -u3   -y1 -fu142 -o1 -mm1
pb intro6.eng    -ft15 -u3   -y1 -fu142 -o1 -mm1
goto ENGHALLO


:/*--------------------------------------------------------------*\
: |                     Learn and understand:                    |
:\*--------------------------------------------------------------*/
:ENGLEARN

pb status1b.eng    -fh7 -ft0  -x1 -y25 -r0  -s0
pb learn.eng      -fh1 -ft15 -m1 -mm1 -x2 -y6
if errorlevel 254 goto ENGMENU
if errorlevel 3   goto ENGFARBELEARN
if errorlevel 2   goto ENGTEXTLEARN
if errorlevel 1   goto ENGMENULEARN

:ENGMENULEARN
pb status8.eng    -fh7 -ft0  -x1  -y25   -r0 -s0
pb batch1.eng     -fh1 -ft15 -y1
pb batch1b.eng    -fh1 -ft15 -y12
pb status9.eng    -fh7 -ft0  -x1  -y25 -r0   -s0  -o1 -mm1 -mx40 -my12
pb status9.eng    -fh7 -ft0  -x1  -y25 -r0   -s0      -mm1 -mx40 -my12
pb batch11.eng    -fh1 -ft15 -y3  -mm1 -o1
pb batch12.eng    -fh1 -ft15 -y4  -mm1 -o1
pb batch13.eng    -fh1 -ft15 -y5  -mm1 -o1
pb batch14.eng    -fh1 -ft15 -y6  -mm1 -o1
pb batch15.eng    -fh1 -ft15 -y7  -mm1 -o1
pb batch16.eng    -fh1 -ft15 -y7  -mm1 -o1
pb batch17.eng    -fh4 -ft14 -y7  -mm1 -o1   -fr142
pb status10.eng   -fh4 -ft14 -x1  -y25 -r0   -s0  -o1 -mm1 -mx40 -my12
rem Note that in the above lines I have often defined the vertical
rem position of the window only, thus asking PowerBatch to center
rem it horizontically by itself.
goto ENGHALLO

:ENGTEXTLEARN
rem This is a typical example for the simple text box, this time to-
rem gether with a status line.
pb status1c.eng   -fh7 -ft0  -x1  -y25 -r0   -s0
pb batch21.eng    -fh1 -ft15 -mm1 -o1
goto ENGLEARN

:ENGFARBELEARN
rem This is a typical example for the simple text box, this time to-
rem gether with a status line.
pb status1c.eng   -fh7 -ft0  -x1  -y25 -r0   -s0
pb batch31.eng    -fh1 -ft15 -mm1 -o1  -y7
goto ENGLEARN


:/*--------------------------------------------------------------*\
: |           Display the color table --- with examples!         |
:\*--------------------------------------------------------------*/
:ENGLOOK

pb status2.eng -fh7  -ft0   -x1  -y25 -r0 -s0
pb farben.eng  -ft15 -u3    -y1  -x2
pb farben2.eng -fh0  -x66   -y5  -r0  -s0
pb farben2.eng -fh1  -x66   -y6  -r0  -s0
pb farben2.eng -fh2  -x66   -y7  -r0  -s0
pb farben2.eng -fh3  -x66   -y8  -r0  -s0
pb farben2.eng -fh4  -x66   -y9  -r0  -s0
pb farben2.eng -fh5  -x66   -y10 -r0  -s0
pb farben2.eng -fh6  -x66   -y11 -r0  -s0
pb farben2.eng -fh7  -x66   -y12 -r0  -s0
pb farben3.eng -fh0  -ft8   -x66 -y13 -r0 -s0
pb farben3.eng -fh0  -ft9   -x66 -y14 -r0 -s0
pb farben3.eng -fh0  -ft10  -x66 -y15 -r0 -s0
pb farben3.eng -fh0  -ft11  -x66 -y16 -r0 -s0
pb farben3.eng -fh0  -ft12  -x66 -y17 -r0 -s0
pb farben3.eng -fh0  -ft13  -x66 -y18 -r0 -s0
pb farben3.eng -fh0  -ft14  -x66 -y19 -r0 -s0
pb farben3.eng -fh0  -ft15  -x66 -y20 -r0 -s0
pb farben3.eng -fh0  -ft143 -x66 -y21 -r0 -s0 -o1 -mm1 -my12 -mx40
rem The above line waits for the keystroke: It is simply the last
rem color example-box that we ask to wait. Of course, you can ask
rem the statusline to wait instead, as well. But I wanted the sta-
rem tusline to be displayed first.
goto ENGHALLO


:/*--------------------------------------------------------------*\
: |                 Show the program's parameters:               |
:\*--------------------------------------------------------------*/
:ENGPARAM

pb param.eng      -fh1 -ft15 -m1 -mm1 -x35 -y6
if errorlevel 254 goto ENGMENU
if errorlevel 7   goto ENGPA7
if errorlevel 6   goto ENGPA6
if errorlevel 5   goto ENGPA5
if errorlevel 4   goto ENGPA4
if errorlevel 3   goto ENGPA3
if errorlevel 2   goto ENGPA2
if errorlevel 1   goto ENGPA1

:ENGPA1
pb status2.eng -fh7 -ft0 -x1 -y25 -r0 -s0
pb param1.eng  -ft15 -o1 -mm1 -u3 -y2 -x2
goto ENGPARAM

:ENGPA2
pb status2.eng -fh7 -ft0 -x1 -y25 -r0 -s0
pb param2.eng  -ft15 -o1 -mm1 -u3 -y2 -x2
goto ENGPARAM

:ENGPA3
pb status2.eng -fh7 -ft0 -x1 -y25 -r0 -s0
pb param3.eng  -ft15 -o1 -mm1 -u3 -y1 -x2
goto ENGPARAM

:ENGPA4
pb status2.eng -fh7 -ft0 -x1 -y25 -r0 -s0
pb param4.eng  -ft15 -o1 -mm1 -u3 -y2 -x2
goto ENGPARAM

:ENGPA5
pb status2.eng -fh7 -ft0 -x1 -y25 -r0 -s0
pb param5.eng  -ft15 -o1 -mm1 -u3 -y1 -x2
goto ENGPARAM

:ENGPA6
pb status2.eng -fh7 -ft0 -x1 -y25 -r0 -s0
pb param6.eng  -ft15 -o1 -mm1 -u3 -y2 -x2
goto ENGPARAM

:ENGPA7
pb status2.eng -fh7 -ft0 -x1 -y25 -r0 -s0
pb param7.eng  -ft15 -o1 -mm1 -u3 -y1 -x2
goto ENGPARAM


:/*--------------------------------------------------------------*\
: |              Show the program info & demonstration:          |
:\*--------------------------------------------------------------*/
:ENGINFO

pb backgrou.men  -fh0 -ft7  -x1  -y1 -r0 -s0
pb titel.eng     -fh1 -ft15 -x2  -y2
pb status3.eng -fh7  -ft0 -x1   -y25  -r0  -s0
pb info1.eng   -ft15 -o1  -mm1   -u3  -r5
pb info2.eng   -ft15 -o1  -mm1   -u3  -r5
pb info3.eng   -ft15 -o1  -mm1   -u3  -r5
pb info4.eng   -ft15 -o1  -mm1   -u3  -r5
pb info5.eng   -ft15 -o1  -mm1   -u3  -r5
pb naomi1.eng  -ft14 -fh4 -fr142 -o1  -mm1 -mx4 -my3
pb naomi2.eng  -ft14 -fh4 -fr142 -o1  -mm1 -mx4 -my3
pb status4.eng -fh2  -ft142 -x1  -y25 -r0  -s0
pb naomi3.eng  -ft14 -fh4 -fr14  -o1  -mm1 -mx4 -my3
pb status5.eng -fh7  -ft0  -x1   -y25 -r0  -s0
pb flagge1.eng -ft14 -fh0  -x2   -y7  -r3
pb status5.eng -fh7  -ft0  -x1   -y25 -r0  -s0  -o1  -mm1 -mx4 -my3
pb flagge2.eng -ft15 -fh4  -x2   -y12 -r3
pb status5.eng -fh7  -ft0  -x1   -y25 -r0  -s0  -o1  -mm1 -mx4 -my3
pb flagge3.eng -ft0  -fh14 -r3   -y17 -x2
pb status5.eng -fh7  -ft0  -x1   -y25 -r0  -s0  -o1  -mm1 -mx4 -my3
pb flagge4.eng -ft14 -fr14 -x56  -y7  -r5
pb status5.eng -fh7  -ft0  -x1   -y25 -r0  -s0  -o1  -mm1 -mx4 -my3
pb status6.eng -fh7  -ft0  -x1   -y25 -r0  -s0
pb kasten1.eng -ft14 -fh0  -r3   -mm1 -mx4 -my3 -y7  -x2  -aw1 -p10
pb kasten2.eng -ft14 -fh4  -r3   -mm1 -mx4 -my3 -y8  -x3  -aw1 -p20
pb kasten3.eng -ft14 -fh14 -r3   -mm1 -mx4 -my3 -y9  -x4  -aw1 -p30
pb kasten4.eng -ft14 -fh0  -r3   -mm1 -mx4 -my3 -y10 -x5  -aw1 -p40
pb kasten5.eng -ft14 -fh4  -r3   -mm1 -mx4 -my3 -y11 -x6  -aw1 -p50
pb kasten6.eng -ft14 -fh14 -r3   -mm1 -mx4 -my3 -y12 -x7  -aw1 -p60
pb status7.eng -fh7  -ft0  -x1   -y25 -r0  -s0
pb kasten7.eng -ft14 -fh3 -fr11  -r3  -mm1 -mx4 -my3 -y11 -o1 -p100
goto ENGHALLO



:/*--------------------------------------------------------------*\
: |               Programmende / The rest is silence.            |
:\*--------------------------------------------------------------*/
:END

cls
